# swagger
PointByte API Client

## Requirements

Dart 1.20.0 and later

## Installation & Usage

```
dependencies:
  pointpos_api: ^0.0.2
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```dart
import 'package:pointpos_api/api.dart';

// TODO Configure API key authorization: JWT
//pointpos_api.api.Configuration.apiKey{'Authorization'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//pointpos_api.api.Configuration.apiKeyPrefix{'Authorization'} = "Bearer";

var api_instance = new CustomerApi();
var authorization = authorization_example; // String | JWT Authorization
var xAPIKey = "rtXekst6HDNxgqTG3fc2QWz5N8v4JsZG"; // String | API Key
var body = new Customer(); // Customer | 

try {
    var result = api_instance.createCustomer(authorization, xAPIKey, body);
    print(result);
} catch (e) {
    print("Exception when calling CustomerApi->createCustomer: $e\n");
}

```

## Documentation for API Endpoints

All URIs are relative to *https://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*CustomerApi* | [**createCustomer**](docs//CustomerApi.md#createcustomer) | **POST** /customer | Create Customer
*CustomerApi* | [**deleteCustomerByID**](docs//CustomerApi.md#deletecustomerbyid) | **DELETE** /customer/{id} | Delete Customer By ID
*CustomerApi* | [**findCustomer**](docs//CustomerApi.md#findcustomer) | **GET** /customer | Get Customer List
*CustomerApi* | [**getCustomerByID**](docs//CustomerApi.md#getcustomerbyid) | **GET** /customer/{id} | Get Customer By ID
*CustomerApi* | [**updateCustomerByID**](docs//CustomerApi.md#updatecustomerbyid) | **PUT** /customer/{id} | Update Customer By ID
*DiscountApi* | [**createDiscount**](docs//DiscountApi.md#creatediscount) | **POST** /discount | Create Discount
*DiscountApi* | [**deleteDiscountByID**](docs//DiscountApi.md#deletediscountbyid) | **DELETE** /discount/{id} | Delete Discount By ID
*DiscountApi* | [**findDiscount**](docs//DiscountApi.md#finddiscount) | **GET** /discount | Get Discount List
*DiscountApi* | [**getDiscountByID**](docs//DiscountApi.md#getdiscountbyid) | **GET** /discount/{id} | Get Discount By ID
*DiscountApi* | [**updateDiscountByID**](docs//DiscountApi.md#updatediscountbyid) | **PUT** /discount/{id} | Update Discount By ID
*EmployeeApi* | [**createEmployee**](docs//EmployeeApi.md#createemployee) | **POST** /employee | Create Employee
*EmployeeApi* | [**deleteEmployeeByID**](docs//EmployeeApi.md#deleteemployeebyid) | **DELETE** /employee/{id} | Delete Employee By ID
*EmployeeApi* | [**findEmployee**](docs//EmployeeApi.md#findemployee) | **GET** /employee | Get Employee List
*EmployeeApi* | [**getEmployeeByID**](docs//EmployeeApi.md#getemployeebyid) | **GET** /employee/{id} | Get Employee By ID
*EmployeeApi* | [**updateEmployeeByID**](docs//EmployeeApi.md#updateemployeebyid) | **PUT** /employee/{id} | Update Employee By ID
*GratuityApi* | [**createGratuity**](docs//GratuityApi.md#creategratuity) | **POST** /gratuity | Create Gratuity
*GratuityApi* | [**deleteGratuityByID**](docs//GratuityApi.md#deletegratuitybyid) | **DELETE** /gratuity/{id} | Delete Gratuity By ID
*GratuityApi* | [**findGratuity**](docs//GratuityApi.md#findgratuity) | **GET** /gratuity | Get Gratuity List
*GratuityApi* | [**getGratuityByID**](docs//GratuityApi.md#getgratuitybyid) | **GET** /gratuity/{id} | Get Gratuity By ID
*GratuityApi* | [**updateGratuityByID**](docs//GratuityApi.md#updategratuitybyid) | **PUT** /gratuity/{id} | Update Gratuity By ID
*IngredientApi* | [**createIngredient**](docs//IngredientApi.md#createingredient) | **POST** /ingredient | Create Ingredient
*IngredientApi* | [**deleteIngredientByID**](docs//IngredientApi.md#deleteingredientbyid) | **DELETE** /ingredient/{id} | Delete Ingredient By ID
*IngredientApi* | [**findIngredient**](docs//IngredientApi.md#findingredient) | **GET** /ingredient | Get Ingredient List
*IngredientApi* | [**getIngredientByID**](docs//IngredientApi.md#getingredientbyid) | **GET** /ingredient/{id} | Get Ingredient By ID
*IngredientApi* | [**updateIngredientByID**](docs//IngredientApi.md#updateingredientbyid) | **PUT** /ingredient/{id} | Update Ingredient By ID
*IngredientCategoryApi* | [**createIngredientcategory**](docs//IngredientCategoryApi.md#createingredientcategory) | **POST** /ingredient-category | Create Ingredientcategory
*IngredientCategoryApi* | [**deleteIngredientcategoryByID**](docs//IngredientCategoryApi.md#deleteingredientcategorybyid) | **DELETE** /ingredient-category/{id} | Delete Ingredientcategory By ID
*IngredientCategoryApi* | [**findIngredientcategory**](docs//IngredientCategoryApi.md#findingredientcategory) | **GET** /ingredient-category | Get Ingredientcategory List
*IngredientCategoryApi* | [**getIngredientcategoryByID**](docs//IngredientCategoryApi.md#getingredientcategorybyid) | **GET** /ingredient-category/{id} | Get Ingredientcategory By ID
*IngredientCategoryApi* | [**updateIngredientcategoryByID**](docs//IngredientCategoryApi.md#updateingredientcategorybyid) | **PUT** /ingredient-category/{id} | Update Ingredientcategory By ID
*ItemApi* | [**createItem**](docs//ItemApi.md#createitem) | **POST** /item | Create Item
*ItemApi* | [**deleteItemByID**](docs//ItemApi.md#deleteitembyid) | **DELETE** /item/{id} | Delete Item By ID
*ItemApi* | [**findItem**](docs//ItemApi.md#finditem) | **GET** /item | Get Item List
*ItemApi* | [**getItemByID**](docs//ItemApi.md#getitembyid) | **GET** /item/{id} | Get Item By ID
*ItemApi* | [**updateItemByID**](docs//ItemApi.md#updateitembyid) | **PUT** /item/{id} | Update Item By ID
*ItemCategoryApi* | [**createItemcategory**](docs//ItemCategoryApi.md#createitemcategory) | **POST** /item-category | Create Itemcategory
*ItemCategoryApi* | [**deleteItemcategoryByID**](docs//ItemCategoryApi.md#deleteitemcategorybyid) | **DELETE** /item-category/{id} | Delete Itemcategory By ID
*ItemCategoryApi* | [**findItemcategory**](docs//ItemCategoryApi.md#finditemcategory) | **GET** /item-category | Get Itemcategory List
*ItemCategoryApi* | [**getItemcategoryByID**](docs//ItemCategoryApi.md#getitemcategorybyid) | **GET** /item-category/{id} | Get Itemcategory By ID
*ItemCategoryApi* | [**updateItemcategoryByID**](docs//ItemCategoryApi.md#updateitemcategorybyid) | **PUT** /item-category/{id} | Update Itemcategory By ID
*LoyaltyProgramApi* | [**createLoyaltyprogram**](docs//LoyaltyProgramApi.md#createloyaltyprogram) | **POST** /loyalty-program | Create Loyaltyprogram
*LoyaltyProgramApi* | [**deleteLoyaltyprogramByID**](docs//LoyaltyProgramApi.md#deleteloyaltyprogrambyid) | **DELETE** /loyalty-program/{id} | Delete Loyaltyprogram By ID
*LoyaltyProgramApi* | [**findLoyaltyprogram**](docs//LoyaltyProgramApi.md#findloyaltyprogram) | **GET** /loyalty-program | Get Loyaltyprogram List
*LoyaltyProgramApi* | [**getLoyaltyprogramByID**](docs//LoyaltyProgramApi.md#getloyaltyprogrambyid) | **GET** /loyalty-program/{id} | Get Loyaltyprogram By ID
*LoyaltyProgramApi* | [**updateLoyaltyprogramByID**](docs//LoyaltyProgramApi.md#updateloyaltyprogrambyid) | **PUT** /loyalty-program/{id} | Update Loyaltyprogram By ID
*MerchantApi* | [**login**](docs//MerchantApi.md#login) | **POST** /merchant/login | Merchant Login
*MerchantApi* | [**signup**](docs//MerchantApi.md#signup) | **POST** /merchant/signup | Merchant Signup
*MerchantAccountApi* | [**createMerchantaccount**](docs//MerchantAccountApi.md#createmerchantaccount) | **POST** /merchant | Create Merchantaccount
*MerchantAccountApi* | [**deleteMerchantaccountByID**](docs//MerchantAccountApi.md#deletemerchantaccountbyid) | **DELETE** /merchant/{id} | Delete Merchantaccount By ID
*MerchantAccountApi* | [**findMerchantaccount**](docs//MerchantAccountApi.md#findmerchantaccount) | **GET** /merchant | Get Merchantaccount List
*MerchantAccountApi* | [**getMerchantaccountByID**](docs//MerchantAccountApi.md#getmerchantaccountbyid) | **GET** /merchant/{id} | Get Merchantaccount By ID
*MerchantAccountApi* | [**updateMerchantaccountByID**](docs//MerchantAccountApi.md#updatemerchantaccountbyid) | **PUT** /merchant/{id} | Update Merchantaccount By ID
*ModifierApi* | [**createModifier**](docs//ModifierApi.md#createmodifier) | **POST** /modifier | Create Modifier
*ModifierApi* | [**deleteModifierByID**](docs//ModifierApi.md#deletemodifierbyid) | **DELETE** /modifier/{id} | Delete Modifier By ID
*ModifierApi* | [**findModifier**](docs//ModifierApi.md#findmodifier) | **GET** /modifier | Get Modifier List
*ModifierApi* | [**getModifierByID**](docs//ModifierApi.md#getmodifierbyid) | **GET** /modifier/{id} | Get Modifier By ID
*ModifierApi* | [**updateModifierByID**](docs//ModifierApi.md#updatemodifierbyid) | **PUT** /modifier/{id} | Update Modifier By ID
*OrderApi* | [**createOrder**](docs//OrderApi.md#createorder) | **POST** /order | Create Order
*OrderApi* | [**deleteOrderByID**](docs//OrderApi.md#deleteorderbyid) | **DELETE** /order/{id} | Delete Order By ID
*OrderApi* | [**findOrder**](docs//OrderApi.md#findorder) | **GET** /order | Get Order List
*OrderApi* | [**getOrderByID**](docs//OrderApi.md#getorderbyid) | **GET** /order/{id} | Get Order By ID
*OrderApi* | [**updateOrderByID**](docs//OrderApi.md#updateorderbyid) | **PUT** /order/{id} | Update Order By ID
*OutletApi* | [**createOutlet**](docs//OutletApi.md#createoutlet) | **POST** /outlet | Create Outlet
*OutletApi* | [**deleteOutletByID**](docs//OutletApi.md#deleteoutletbyid) | **DELETE** /outlet/{id} | Delete Outlet By ID
*OutletApi* | [**findOutlet**](docs//OutletApi.md#findoutlet) | **GET** /outlet | Get Outlet List
*OutletApi* | [**getOutletByID**](docs//OutletApi.md#getoutletbyid) | **GET** /outlet/{id} | Get Outlet By ID
*OutletApi* | [**updateOutletByID**](docs//OutletApi.md#updateoutletbyid) | **PUT** /outlet/{id} | Update Outlet By ID
*PromoApi* | [**createPromo**](docs//PromoApi.md#createpromo) | **POST** /promo | Create Promo
*PromoApi* | [**deletePromoByID**](docs//PromoApi.md#deletepromobyid) | **DELETE** /promo/{id} | Delete Promo By ID
*PromoApi* | [**findPromo**](docs//PromoApi.md#findpromo) | **GET** /promo | Get Promo List
*PromoApi* | [**getPromoByID**](docs//PromoApi.md#getpromobyid) | **GET** /promo/{id} | Get Promo By ID
*PromoApi* | [**updatePromoByID**](docs//PromoApi.md#updatepromobyid) | **PUT** /promo/{id} | Update Promo By ID
*PurchaseOrderApi* | [**createPurchaseorder**](docs//PurchaseOrderApi.md#createpurchaseorder) | **POST** /purchase-order | Create Purchaseorder
*PurchaseOrderApi* | [**deletePurchaseorderByID**](docs//PurchaseOrderApi.md#deletepurchaseorderbyid) | **DELETE** /purchase-order/{outletId} | Delete Purchaseorder By ID
*PurchaseOrderApi* | [**findPurchaseorder**](docs//PurchaseOrderApi.md#findpurchaseorder) | **GET** /purchase-order | Get Purchaseorder List
*PurchaseOrderApi* | [**getPurchaseorderByID**](docs//PurchaseOrderApi.md#getpurchaseorderbyid) | **GET** /purchase-order/{outletId} | Get Purchaseorder By ID
*PurchaseOrderApi* | [**updatePurchaseorderByID**](docs//PurchaseOrderApi.md#updatepurchaseorderbyid) | **PUT** /purchase-order/{outletId} | Update Purchaseorder By ID
*RecipeApi* | [**createRecipe**](docs//RecipeApi.md#createrecipe) | **POST** /recipe | Create Recipe
*RecipeApi* | [**deleteRecipeByID**](docs//RecipeApi.md#deleterecipebyid) | **DELETE** /recipe/{itemId} | Delete Recipe By ID
*RecipeApi* | [**findRecipe**](docs//RecipeApi.md#findrecipe) | **GET** /recipe | Get Recipe List
*RecipeApi* | [**getRecipeByID**](docs//RecipeApi.md#getrecipebyid) | **GET** /recipe/{itemId} | Get Recipe By ID
*RecipeApi* | [**updateRecipeByID**](docs//RecipeApi.md#updaterecipebyid) | **PUT** /recipe/{itemId} | Update Recipe By ID
*RoleApi* | [**createRole**](docs//RoleApi.md#createrole) | **POST** /role | Create Role
*RoleApi* | [**deleteRoleByID**](docs//RoleApi.md#deleterolebyid) | **DELETE** /role/{id} | Delete Role By ID
*RoleApi* | [**findRole**](docs//RoleApi.md#findrole) | **GET** /role | Get Role List
*RoleApi* | [**getRoleByID**](docs//RoleApi.md#getrolebyid) | **GET** /role/{id} | Get Role By ID
*RoleApi* | [**updateRoleByID**](docs//RoleApi.md#updaterolebyid) | **PUT** /role/{id} | Update Role By ID
*RolePermissionApi* | [**createRolepermission**](docs//RolePermissionApi.md#createrolepermission) | **POST** /role-permission | Create Rolepermission
*RolePermissionApi* | [**deleteRolepermissionByID**](docs//RolePermissionApi.md#deleterolepermissionbyid) | **DELETE** /role-permission/{id} | Delete Rolepermission By ID
*RolePermissionApi* | [**findRolepermission**](docs//RolePermissionApi.md#findrolepermission) | **GET** /role-permission | Get Rolepermission List
*RolePermissionApi* | [**getRolepermissionByID**](docs//RolePermissionApi.md#getrolepermissionbyid) | **GET** /role-permission/{id} | Get Rolepermission By ID
*RolePermissionApi* | [**updateRolepermissionByID**](docs//RolePermissionApi.md#updaterolepermissionbyid) | **PUT** /role-permission/{id} | Update Rolepermission By ID
*SalesTypeApi* | [**createSalestype**](docs//SalesTypeApi.md#createsalestype) | **POST** /sales-type | Create Salestype
*SalesTypeApi* | [**deleteSalestypeByID**](docs//SalesTypeApi.md#deletesalestypebyid) | **DELETE** /sales-type/{name} | Delete Salestype By ID
*SalesTypeApi* | [**findSalestype**](docs//SalesTypeApi.md#findsalestype) | **GET** /sales-type | Get Salestype List
*SalesTypeApi* | [**getSalestypeByID**](docs//SalesTypeApi.md#getsalestypebyid) | **GET** /sales-type/{name} | Get Salestype By ID
*SalesTypeApi* | [**updateSalestypeByID**](docs//SalesTypeApi.md#updatesalestypebyid) | **PUT** /sales-type/{name} | Update Salestype By ID
*SupplierApi* | [**createSupplier**](docs//SupplierApi.md#createsupplier) | **POST** /supplier | Create Supplier
*SupplierApi* | [**deleteSupplierByID**](docs//SupplierApi.md#deletesupplierbyid) | **DELETE** /supplier/{id} | Delete Supplier By ID
*SupplierApi* | [**findSupplier**](docs//SupplierApi.md#findsupplier) | **GET** /supplier | Get Supplier List
*SupplierApi* | [**getSupplierByID**](docs//SupplierApi.md#getsupplierbyid) | **GET** /supplier/{id} | Get Supplier By ID
*SupplierApi* | [**updateSupplierByID**](docs//SupplierApi.md#updatesupplierbyid) | **PUT** /supplier/{id} | Update Supplier By ID
*TableApi* | [**createTable**](docs//TableApi.md#createtable) | **POST** /table | Create Table
*TableApi* | [**deleteTableByID**](docs//TableApi.md#deletetablebyid) | **DELETE** /table/{id} | Delete Table By ID
*TableApi* | [**findTable**](docs//TableApi.md#findtable) | **GET** /table | Get Table List
*TableApi* | [**getTableByID**](docs//TableApi.md#gettablebyid) | **GET** /table/{id} | Get Table By ID
*TableApi* | [**updateTableByID**](docs//TableApi.md#updatetablebyid) | **PUT** /table/{id} | Update Table By ID
*TableGroupApi* | [**createTablegroup**](docs//TableGroupApi.md#createtablegroup) | **POST** /table-group | Create Tablegroup
*TableGroupApi* | [**deleteTablegroupByID**](docs//TableGroupApi.md#deletetablegroupbyid) | **DELETE** /table-group/{id} | Delete Tablegroup By ID
*TableGroupApi* | [**findTablegroup**](docs//TableGroupApi.md#findtablegroup) | **GET** /table-group | Get Tablegroup List
*TableGroupApi* | [**getTablegroupByID**](docs//TableGroupApi.md#gettablegroupbyid) | **GET** /table-group/{id} | Get Tablegroup By ID
*TableGroupApi* | [**updateTablegroupByID**](docs//TableGroupApi.md#updatetablegroupbyid) | **PUT** /table-group/{id} | Update Tablegroup By ID
*TaxApi* | [**createTax**](docs//TaxApi.md#createtax) | **POST** /tax | Create Tax
*TaxApi* | [**deleteTaxByID**](docs//TaxApi.md#deletetaxbyid) | **DELETE** /tax/{id} | Delete Tax By ID
*TaxApi* | [**findTax**](docs//TaxApi.md#findtax) | **GET** /tax | Get Tax List
*TaxApi* | [**getTaxByID**](docs//TaxApi.md#gettaxbyid) | **GET** /tax/{id} | Get Tax By ID
*TaxApi* | [**updateTaxByID**](docs//TaxApi.md#updatetaxbyid) | **PUT** /tax/{id} | Update Tax By ID
*UnitApi* | [**createUnit**](docs//UnitApi.md#createunit) | **POST** /unit | Create Unit
*UnitApi* | [**deleteUnitByID**](docs//UnitApi.md#deleteunitbyid) | **DELETE** /unit/{id} | Delete Unit By ID
*UnitApi* | [**findUnit**](docs//UnitApi.md#findunit) | **GET** /unit | Get Unit List
*UnitApi* | [**getUnitByID**](docs//UnitApi.md#getunitbyid) | **GET** /unit/{id} | Get Unit By ID
*UnitApi* | [**updateUnitByID**](docs//UnitApi.md#updateunitbyid) | **PUT** /unit/{id} | Update Unit By ID


## Documentation For Models

 - [Customer](docs//Customer.md)
 - [Discount](docs//Discount.md)
 - [Employee](docs//Employee.md)
 - [Exception](docs//Exception.md)
 - [Gratuity](docs//Gratuity.md)
 - [Ingredient](docs//Ingredient.md)
 - [IngredientCategory](docs//IngredientCategory.md)
 - [IngredientCostOfGoodsSold](docs//IngredientCostOfGoodsSold.md)
 - [IngredientInventory](docs//IngredientInventory.md)
 - [InlineResponse200](docs//InlineResponse200.md)
 - [Item](docs//Item.md)
 - [ItemCategory](docs//ItemCategory.md)
 - [ItemCostOfGoodsSold](docs//ItemCostOfGoodsSold.md)
 - [ItemInventory](docs//ItemInventory.md)
 - [ItemVariants](docs//ItemVariants.md)
 - [Login](docs//Login.md)
 - [LoyaltyProgram](docs//LoyaltyProgram.md)
 - [LoyaltyProgramPointFromBuyItem](docs//LoyaltyProgramPointFromBuyItem.md)
 - [LoyaltyProgramPointFromBuyItemEligibleCategories](docs//LoyaltyProgramPointFromBuyItemEligibleCategories.md)
 - [LoyaltyProgramPointFromBuyItemEligibleItems](docs//LoyaltyProgramPointFromBuyItemEligibleItems.md)
 - [LoyaltyProgramPointFromTotalSpent](docs//LoyaltyProgramPointFromTotalSpent.md)
 - [LoyaltyProgramRedeemRules](docs//LoyaltyProgramRedeemRules.md)
 - [MerchantAccount](docs//MerchantAccount.md)
 - [MerchantAccountBusinessInfo](docs//MerchantAccountBusinessInfo.md)
 - [MerchantAccountIdentification](docs//MerchantAccountIdentification.md)
 - [MerchantAccountPersonalDetails](docs//MerchantAccountPersonalDetails.md)
 - [MerchantAccountPersonalDetailsEmail](docs//MerchantAccountPersonalDetailsEmail.md)
 - [MerchantAccountPersonalDetailsPhone](docs//MerchantAccountPersonalDetailsPhone.md)
 - [MerchantAccountPublicProfile](docs//MerchantAccountPublicProfile.md)
 - [Modifier](docs//Modifier.md)
 - [ModifierOptions](docs//ModifierOptions.md)
 - [Order](docs//Order.md)
 - [OrderCash](docs//OrderCash.md)
 - [OrderDiscounts](docs//OrderDiscounts.md)
 - [OrderItems](docs//OrderItems.md)
 - [OrderModifiers](docs//OrderModifiers.md)
 - [OrderPayments](docs//OrderPayments.md)
 - [OrderSentReceipts](docs//OrderSentReceipts.md)
 - [Outlet](docs//Outlet.md)
 - [OutletReceiptSettings](docs//OutletReceiptSettings.md)
 - [OutletReceiptSettingsOutletInfo](docs//OutletReceiptSettingsOutletInfo.md)
 - [Promo](docs//Promo.md)
 - [PromoPromoPeriod](docs//PromoPromoPeriod.md)
 - [PromoPromoPeriodDateRange](docs//PromoPromoPeriodDateRange.md)
 - [PromoPromoPeriodTimeRange](docs//PromoPromoPeriodTimeRange.md)
 - [PromoPromoPeriodWeekDay](docs//PromoPromoPeriodWeekDay.md)
 - [PromoRequirement](docs//PromoRequirement.md)
 - [PromoRequirementEligibleCategories](docs//PromoRequirementEligibleCategories.md)
 - [PromoRequirementEligibleItems](docs//PromoRequirementEligibleItems.md)
 - [PromoReward](docs//PromoReward.md)
 - [PromoRewardDiscount](docs//PromoRewardDiscount.md)
 - [PurchaseOrder](docs//PurchaseOrder.md)
 - [PurchaseOrderIngredients](docs//PurchaseOrderIngredients.md)
 - [Recipe](docs//Recipe.md)
 - [RecipeIngredients](docs//RecipeIngredients.md)
 - [Role](docs//Role.md)
 - [RolePermission](docs//RolePermission.md)
 - [SalesType](docs//SalesType.md)
 - [Signup](docs//Signup.md)
 - [Supplier](docs//Supplier.md)
 - [Table](docs//Table.md)
 - [TableGroup](docs//TableGroup.md)
 - [TableLocation](docs//TableLocation.md)
 - [Tax](docs//Tax.md)
 - [Unit](docs//Unit.md)
 - [ForbiddenException](docs//ForbiddenException.md)
 - [InternalServerErrorException](docs//InternalServerErrorException.md)
 - [NotFoundException](docs//NotFoundException.md)
 - [UnauthorizedException](docs//UnauthorizedException.md)
 - [ValidationException](docs//ValidationException.md)


## Documentation For Authorization


## APIKey

- **Type**: API key
- **API key parameter name**: X-API-Key
- **Location**: HTTP header

## JWT

- **Type**: API key
- **API key parameter name**: Authorization
- **Location**: HTTP header


## Author




