part of swagger.api;



class LoyaltyProgramApi {
  final ApiClient apiClient;

  LoyaltyProgramApi([ApiClient apiClient]) : apiClient = apiClient ?? defaultApiClient;

  /// Create Loyaltyprogram
  ///
  /// Create Loyaltyprogram
  Future<LoyaltyProgram> createLoyaltyprogram(String authorization, String xAPIKey, LoyaltyProgram body) async {
    Object postBody = body;

    // verify required params are set
    if(authorization == null) {
     throw new ApiException(400, "Missing required param: authorization");
    }
    if(xAPIKey == null) {
     throw new ApiException(400, "Missing required param: xAPIKey");
    }
    if(body == null) {
     throw new ApiException(400, "Missing required param: body");
    }

    // create path and map variables
    String path = "/loyalty-program".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    headerParams["Authorization"] = authorization;
headerParams["X-API-Key"] = xAPIKey;

    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["JWT"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'POST',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return apiClient.deserialize(response.body, 'LoyaltyProgram') as LoyaltyProgram ;
    } else {
      return null;
    }
  }
  /// Delete Loyaltyprogram By ID
  ///
  /// Delete Loyaltyprogram By ID
  Future deleteLoyaltyprogramByID(String authorization, String xAPIKey, String id) async {
    Object postBody = null;

    // verify required params are set
    if(authorization == null) {
     throw new ApiException(400, "Missing required param: authorization");
    }
    if(xAPIKey == null) {
     throw new ApiException(400, "Missing required param: xAPIKey");
    }
    if(id == null) {
     throw new ApiException(400, "Missing required param: id");
    }

    // create path and map variables
    String path = "/loyalty-program/{id}".replaceAll("{format}","json").replaceAll("{" + "id" + "}", id.toString());

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    headerParams["Authorization"] = authorization;
headerParams["X-API-Key"] = xAPIKey;

    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["JWT"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'DELETE',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return ;
    } else {
      return ;
    }
  }
  /// Get Loyaltyprogram List
  ///
  /// Get Loyaltyprogram  List
  Future<List<LoyaltyProgram>> findLoyaltyprogram(String authorization, String xAPIKey, { num limit, num offset, String sort, String direction, List<String> filter }) async {
    Object postBody = null;

    // verify required params are set
    if(authorization == null) {
     throw new ApiException(400, "Missing required param: authorization");
    }
    if(xAPIKey == null) {
     throw new ApiException(400, "Missing required param: xAPIKey");
    }

    // create path and map variables
    String path = "/loyalty-program".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if(limit != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "limit", limit));
    }
    if(offset != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "offset", offset));
    }
    if(sort != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "sort", sort));
    }
    if(direction != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "direction", direction));
    }
    if(filter != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("multi", "filter", filter));
    }
    headerParams["Authorization"] = authorization;
headerParams["X-API-Key"] = xAPIKey;

    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["JWT"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return apiClient.deserialize(response.body, 'List<LoyaltyProgram>') as List<LoyaltyProgram> ;
    } else {
      return null;
    }
  }
  /// Get Loyaltyprogram By ID
  ///
  /// Get Loyaltyprogram By ID
  Future<LoyaltyProgram> getLoyaltyprogramByID(String authorization, String xAPIKey, String id) async {
    Object postBody = null;

    // verify required params are set
    if(authorization == null) {
     throw new ApiException(400, "Missing required param: authorization");
    }
    if(xAPIKey == null) {
     throw new ApiException(400, "Missing required param: xAPIKey");
    }
    if(id == null) {
     throw new ApiException(400, "Missing required param: id");
    }

    // create path and map variables
    String path = "/loyalty-program/{id}".replaceAll("{format}","json").replaceAll("{" + "id" + "}", id.toString());

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    headerParams["Authorization"] = authorization;
headerParams["X-API-Key"] = xAPIKey;

    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["JWT"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return apiClient.deserialize(response.body, 'LoyaltyProgram') as LoyaltyProgram ;
    } else {
      return null;
    }
  }
  /// Update Loyaltyprogram By ID
  ///
  /// Update [object Object] By ID
  Future<LoyaltyProgram> updateLoyaltyprogramByID(String authorization, String xAPIKey, String id, LoyaltyProgram body) async {
    Object postBody = body;

    // verify required params are set
    if(authorization == null) {
     throw new ApiException(400, "Missing required param: authorization");
    }
    if(xAPIKey == null) {
     throw new ApiException(400, "Missing required param: xAPIKey");
    }
    if(id == null) {
     throw new ApiException(400, "Missing required param: id");
    }
    if(body == null) {
     throw new ApiException(400, "Missing required param: body");
    }

    // create path and map variables
    String path = "/loyalty-program/{id}".replaceAll("{format}","json").replaceAll("{" + "id" + "}", id.toString());

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    headerParams["Authorization"] = authorization;
headerParams["X-API-Key"] = xAPIKey;

    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["JWT"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'PUT',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return apiClient.deserialize(response.body, 'LoyaltyProgram') as LoyaltyProgram ;
    } else {
      return null;
    }
  }
}
