part of swagger.api;



class PurchaseOrderApi {
  final ApiClient apiClient;

  PurchaseOrderApi([ApiClient apiClient]) : apiClient = apiClient ?? defaultApiClient;

  /// Create Purchaseorder
  ///
  /// Create Purchaseorder
  Future<PurchaseOrder> createPurchaseorder(String authorization, String xAPIKey, PurchaseOrder body) async {
    Object postBody = body;

    // verify required params are set
    if(authorization == null) {
     throw new ApiException(400, "Missing required param: authorization");
    }
    if(xAPIKey == null) {
     throw new ApiException(400, "Missing required param: xAPIKey");
    }
    if(body == null) {
     throw new ApiException(400, "Missing required param: body");
    }

    // create path and map variables
    String path = "/purchase-order".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    headerParams["Authorization"] = authorization;
headerParams["X-API-Key"] = xAPIKey;

    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["JWT"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'POST',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return apiClient.deserialize(response.body, 'PurchaseOrder') as PurchaseOrder ;
    } else {
      return null;
    }
  }
  /// Delete Purchaseorder By ID
  ///
  /// Delete Purchaseorder By ID
  Future deletePurchaseorderByID(String authorization, String xAPIKey, String outletId) async {
    Object postBody = null;

    // verify required params are set
    if(authorization == null) {
     throw new ApiException(400, "Missing required param: authorization");
    }
    if(xAPIKey == null) {
     throw new ApiException(400, "Missing required param: xAPIKey");
    }
    if(outletId == null) {
     throw new ApiException(400, "Missing required param: outletId");
    }

    // create path and map variables
    String path = "/purchase-order/{outletId}".replaceAll("{format}","json").replaceAll("{" + "outletId" + "}", outletId.toString());

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    headerParams["Authorization"] = authorization;
headerParams["X-API-Key"] = xAPIKey;

    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["JWT"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'DELETE',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return ;
    } else {
      return ;
    }
  }
  /// Get Purchaseorder List
  ///
  /// Get Purchaseorder  List
  Future<List<PurchaseOrder>> findPurchaseorder(String authorization, String xAPIKey, { num limit, num offset, String sort, String direction, List<String> filter }) async {
    Object postBody = null;

    // verify required params are set
    if(authorization == null) {
     throw new ApiException(400, "Missing required param: authorization");
    }
    if(xAPIKey == null) {
     throw new ApiException(400, "Missing required param: xAPIKey");
    }

    // create path and map variables
    String path = "/purchase-order".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if(limit != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "limit", limit));
    }
    if(offset != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "offset", offset));
    }
    if(sort != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "sort", sort));
    }
    if(direction != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "direction", direction));
    }
    if(filter != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("multi", "filter", filter));
    }
    headerParams["Authorization"] = authorization;
headerParams["X-API-Key"] = xAPIKey;

    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["JWT"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return apiClient.deserialize(response.body, 'List<PurchaseOrder>') as List<PurchaseOrder> ;
    } else {
      return null;
    }
  }
  /// Get Purchaseorder By ID
  ///
  /// Get Purchaseorder By ID
  Future<PurchaseOrder> getPurchaseorderByID(String authorization, String xAPIKey, String outletId) async {
    Object postBody = null;

    // verify required params are set
    if(authorization == null) {
     throw new ApiException(400, "Missing required param: authorization");
    }
    if(xAPIKey == null) {
     throw new ApiException(400, "Missing required param: xAPIKey");
    }
    if(outletId == null) {
     throw new ApiException(400, "Missing required param: outletId");
    }

    // create path and map variables
    String path = "/purchase-order/{outletId}".replaceAll("{format}","json").replaceAll("{" + "outletId" + "}", outletId.toString());

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    headerParams["Authorization"] = authorization;
headerParams["X-API-Key"] = xAPIKey;

    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["JWT"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return apiClient.deserialize(response.body, 'PurchaseOrder') as PurchaseOrder ;
    } else {
      return null;
    }
  }
  /// Update Purchaseorder By ID
  ///
  /// Update [object Object] By ID
  Future<PurchaseOrder> updatePurchaseorderByID(String authorization, String xAPIKey, String outletId, PurchaseOrder body) async {
    Object postBody = body;

    // verify required params are set
    if(authorization == null) {
     throw new ApiException(400, "Missing required param: authorization");
    }
    if(xAPIKey == null) {
     throw new ApiException(400, "Missing required param: xAPIKey");
    }
    if(outletId == null) {
     throw new ApiException(400, "Missing required param: outletId");
    }
    if(body == null) {
     throw new ApiException(400, "Missing required param: body");
    }

    // create path and map variables
    String path = "/purchase-order/{outletId}".replaceAll("{format}","json").replaceAll("{" + "outletId" + "}", outletId.toString());

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    headerParams["Authorization"] = authorization;
headerParams["X-API-Key"] = xAPIKey;

    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["JWT"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'PUT',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return apiClient.deserialize(response.body, 'PurchaseOrder') as PurchaseOrder ;
    } else {
      return null;
    }
  }
}
