part of swagger.api;



class SalesTypeApi {
  final ApiClient apiClient;

  SalesTypeApi([ApiClient apiClient]) : apiClient = apiClient ?? defaultApiClient;

  /// Create Salestype
  ///
  /// Create Salestype
  Future<SalesType> createSalestype(String authorization, String xAPIKey, SalesType body) async {
    Object postBody = body;

    // verify required params are set
    if(authorization == null) {
     throw new ApiException(400, "Missing required param: authorization");
    }
    if(xAPIKey == null) {
     throw new ApiException(400, "Missing required param: xAPIKey");
    }
    if(body == null) {
     throw new ApiException(400, "Missing required param: body");
    }

    // create path and map variables
    String path = "/sales-type".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    headerParams["Authorization"] = authorization;
headerParams["X-API-Key"] = xAPIKey;

    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["JWT"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'POST',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return apiClient.deserialize(response.body, 'SalesType') as SalesType ;
    } else {
      return null;
    }
  }
  /// Delete Salestype By ID
  ///
  /// Delete Salestype By ID
  Future deleteSalestypeByID(String authorization, String xAPIKey, String name) async {
    Object postBody = null;

    // verify required params are set
    if(authorization == null) {
     throw new ApiException(400, "Missing required param: authorization");
    }
    if(xAPIKey == null) {
     throw new ApiException(400, "Missing required param: xAPIKey");
    }
    if(name == null) {
     throw new ApiException(400, "Missing required param: name");
    }

    // create path and map variables
    String path = "/sales-type/{name}".replaceAll("{format}","json").replaceAll("{" + "name" + "}", name.toString());

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    headerParams["Authorization"] = authorization;
headerParams["X-API-Key"] = xAPIKey;

    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["JWT"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'DELETE',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return ;
    } else {
      return ;
    }
  }
  /// Get Salestype List
  ///
  /// Get Salestype  List
  Future<List<SalesType>> findSalestype(String authorization, String xAPIKey, { num limit, num offset, String sort, String direction, List<String> filter }) async {
    Object postBody = null;

    // verify required params are set
    if(authorization == null) {
     throw new ApiException(400, "Missing required param: authorization");
    }
    if(xAPIKey == null) {
     throw new ApiException(400, "Missing required param: xAPIKey");
    }

    // create path and map variables
    String path = "/sales-type".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if(limit != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "limit", limit));
    }
    if(offset != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "offset", offset));
    }
    if(sort != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "sort", sort));
    }
    if(direction != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "direction", direction));
    }
    if(filter != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("multi", "filter", filter));
    }
    headerParams["Authorization"] = authorization;
headerParams["X-API-Key"] = xAPIKey;

    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["JWT"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return apiClient.deserialize(response.body, 'List<SalesType>') as List<SalesType> ;
    } else {
      return null;
    }
  }
  /// Get Salestype By ID
  ///
  /// Get Salestype By ID
  Future<SalesType> getSalestypeByID(String authorization, String xAPIKey, String name) async {
    Object postBody = null;

    // verify required params are set
    if(authorization == null) {
     throw new ApiException(400, "Missing required param: authorization");
    }
    if(xAPIKey == null) {
     throw new ApiException(400, "Missing required param: xAPIKey");
    }
    if(name == null) {
     throw new ApiException(400, "Missing required param: name");
    }

    // create path and map variables
    String path = "/sales-type/{name}".replaceAll("{format}","json").replaceAll("{" + "name" + "}", name.toString());

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    headerParams["Authorization"] = authorization;
headerParams["X-API-Key"] = xAPIKey;

    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["JWT"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return apiClient.deserialize(response.body, 'SalesType') as SalesType ;
    } else {
      return null;
    }
  }
  /// Update Salestype By ID
  ///
  /// Update [object Object] By ID
  Future<SalesType> updateSalestypeByID(String authorization, String xAPIKey, String name, SalesType body) async {
    Object postBody = body;

    // verify required params are set
    if(authorization == null) {
     throw new ApiException(400, "Missing required param: authorization");
    }
    if(xAPIKey == null) {
     throw new ApiException(400, "Missing required param: xAPIKey");
    }
    if(name == null) {
     throw new ApiException(400, "Missing required param: name");
    }
    if(body == null) {
     throw new ApiException(400, "Missing required param: body");
    }

    // create path and map variables
    String path = "/sales-type/{name}".replaceAll("{format}","json").replaceAll("{" + "name" + "}", name.toString());

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    headerParams["Authorization"] = authorization;
headerParams["X-API-Key"] = xAPIKey;

    List<String> contentTypes = ["application/json"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["JWT"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'PUT',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return apiClient.deserialize(response.body, 'SalesType') as SalesType ;
    } else {
      return null;
    }
  }
}
