part of swagger.api;

class QueryParam {
  String name;
  String value;

  QueryParam(this.name, this.value);
}

class ApiClient {

  String basePath;
  var client = new BrowserClient();

  Map<String, String> _defaultHeaderMap = {};
  Map<String, Authentication> _authentications = {};

  final dson = new Dartson.JSON()
      ..addTransformer(new DateTimeParser(), DateTime);

  final _RegList = new RegExp(r'^List<(.*)>$');
  final _RegMap = new RegExp(r'^Map<String,(.*)>$');

  ApiClient({this.basePath: "https://localhost"}) {
    // Setup authentications (key: authentication name, value: authentication).
    _authentications['APIKey'] = new ApiKeyAuth("header", "X-API-Key");
    _authentications['JWT'] = new ApiKeyAuth("header", "Authorization");
  }

  void addDefaultHeader(String key, String value) {
     _defaultHeaderMap[key] = value;
  }

  dynamic _deserialize(dynamic value, String targetType) {
    try {
      switch (targetType) {
        case 'String':
          return '$value';
        case 'int':
          return value is int ? value : int.parse('$value');
        case 'bool':
          return value is bool ? value : '$value'.toLowerCase() == 'true';
        case 'double':
          return value is double ? value : double.parse('$value');
        case 'Customer':
          return dson.map(value, new Customer());
        case 'Discount':
          return dson.map(value, new Discount());
        case 'Employee':
          return dson.map(value, new Employee());
        case 'Exception':
          return dson.map(value, new Exception());
        case 'Gratuity':
          return dson.map(value, new Gratuity());
        case 'Ingredient':
          return dson.map(value, new Ingredient());
        case 'IngredientCategory':
          return dson.map(value, new IngredientCategory());
        case 'IngredientCostOfGoodsSold':
          return dson.map(value, new IngredientCostOfGoodsSold());
        case 'IngredientInventory':
          return dson.map(value, new IngredientInventory());
        case 'InlineResponse200':
          return dson.map(value, new InlineResponse200());
        case 'Item':
          return dson.map(value, new Item());
        case 'ItemCategory':
          return dson.map(value, new ItemCategory());
        case 'ItemCostOfGoodsSold':
          return dson.map(value, new ItemCostOfGoodsSold());
        case 'ItemInventory':
          return dson.map(value, new ItemInventory());
        case 'ItemVariants':
          return dson.map(value, new ItemVariants());
        case 'Login':
          return dson.map(value, new Login());
        case 'LoyaltyProgram':
          return dson.map(value, new LoyaltyProgram());
        case 'LoyaltyProgramPointFromBuyItem':
          return dson.map(value, new LoyaltyProgramPointFromBuyItem());
        case 'LoyaltyProgramPointFromBuyItemEligibleCategories':
          return dson.map(value, new LoyaltyProgramPointFromBuyItemEligibleCategories());
        case 'LoyaltyProgramPointFromBuyItemEligibleItems':
          return dson.map(value, new LoyaltyProgramPointFromBuyItemEligibleItems());
        case 'LoyaltyProgramPointFromTotalSpent':
          return dson.map(value, new LoyaltyProgramPointFromTotalSpent());
        case 'LoyaltyProgramRedeemRules':
          return dson.map(value, new LoyaltyProgramRedeemRules());
        case 'MerchantAccount':
          return dson.map(value, new MerchantAccount());
        case 'MerchantAccountBusinessInfo':
          return dson.map(value, new MerchantAccountBusinessInfo());
        case 'MerchantAccountIdentification':
          return dson.map(value, new MerchantAccountIdentification());
        case 'MerchantAccountPersonalDetails':
          return dson.map(value, new MerchantAccountPersonalDetails());
        case 'MerchantAccountPersonalDetailsEmail':
          return dson.map(value, new MerchantAccountPersonalDetailsEmail());
        case 'MerchantAccountPersonalDetailsPhone':
          return dson.map(value, new MerchantAccountPersonalDetailsPhone());
        case 'MerchantAccountPublicProfile':
          return dson.map(value, new MerchantAccountPublicProfile());
        case 'Modifier':
          return dson.map(value, new Modifier());
        case 'ModifierOptions':
          return dson.map(value, new ModifierOptions());
        case 'Order':
          return dson.map(value, new Order());
        case 'OrderCash':
          return dson.map(value, new OrderCash());
        case 'OrderDiscounts':
          return dson.map(value, new OrderDiscounts());
        case 'OrderItems':
          return dson.map(value, new OrderItems());
        case 'OrderModifiers':
          return dson.map(value, new OrderModifiers());
        case 'OrderPayments':
          return dson.map(value, new OrderPayments());
        case 'OrderSentReceipts':
          return dson.map(value, new OrderSentReceipts());
        case 'Outlet':
          return dson.map(value, new Outlet());
        case 'OutletReceiptSettings':
          return dson.map(value, new OutletReceiptSettings());
        case 'OutletReceiptSettingsOutletInfo':
          return dson.map(value, new OutletReceiptSettingsOutletInfo());
        case 'Promo':
          return dson.map(value, new Promo());
        case 'PromoPromoPeriod':
          return dson.map(value, new PromoPromoPeriod());
        case 'PromoPromoPeriodDateRange':
          return dson.map(value, new PromoPromoPeriodDateRange());
        case 'PromoPromoPeriodTimeRange':
          return dson.map(value, new PromoPromoPeriodTimeRange());
        case 'PromoPromoPeriodWeekDay':
          return dson.map(value, new PromoPromoPeriodWeekDay());
        case 'PromoRequirement':
          return dson.map(value, new PromoRequirement());
        case 'PromoRequirementEligibleCategories':
          return dson.map(value, new PromoRequirementEligibleCategories());
        case 'PromoRequirementEligibleItems':
          return dson.map(value, new PromoRequirementEligibleItems());
        case 'PromoReward':
          return dson.map(value, new PromoReward());
        case 'PromoRewardDiscount':
          return dson.map(value, new PromoRewardDiscount());
        case 'PurchaseOrder':
          return dson.map(value, new PurchaseOrder());
        case 'PurchaseOrderIngredients':
          return dson.map(value, new PurchaseOrderIngredients());
        case 'Recipe':
          return dson.map(value, new Recipe());
        case 'RecipeIngredients':
          return dson.map(value, new RecipeIngredients());
        case 'Role':
          return dson.map(value, new Role());
        case 'RolePermission':
          return dson.map(value, new RolePermission());
        case 'SalesType':
          return dson.map(value, new SalesType());
        case 'Signup':
          return dson.map(value, new Signup());
        case 'Supplier':
          return dson.map(value, new Supplier());
        case 'Table':
          return dson.map(value, new Table());
        case 'TableGroup':
          return dson.map(value, new TableGroup());
        case 'TableLocation':
          return dson.map(value, new TableLocation());
        case 'Tax':
          return dson.map(value, new Tax());
        case 'Unit':
          return dson.map(value, new Unit());
        case 'ForbiddenException':
          return dson.map(value, new ForbiddenException());
        case 'InternalServerErrorException':
          return dson.map(value, new InternalServerErrorException());
        case 'NotFoundException':
          return dson.map(value, new NotFoundException());
        case 'UnauthorizedException':
          return dson.map(value, new UnauthorizedException());
        case 'ValidationException':
          return dson.map(value, new ValidationException());
        default:
          {
            Match match;
            if (value is List &&
                (match = _RegList.firstMatch(targetType)) != null) {
              var newTargetType = match[1];
              return value.map((v) => _deserialize(v, newTargetType)).toList();
            } else if (value is Map &&
                (match = _RegMap.firstMatch(targetType)) != null) {
              var newTargetType = match[1];
              return new Map.fromIterables(value.keys,
                  value.values.map((v) => _deserialize(v, newTargetType)));
            }
          }
      }
    } catch (e, stack) {
      throw new ApiException.withInner(500, 'Exception during deserialization.', e, stack);
    }
    throw new ApiException(500, 'Could not find a suitable class for deserialization');
  }

  dynamic deserialize(String json, String targetType) {
    // Remove all spaces.  Necessary for reg expressions as well.
    targetType = targetType.replaceAll(' ', '');

    if (targetType == 'String') return json;

    var decodedJson = JSON.decode(json);
    return _deserialize(decodedJson, targetType);
  }

  String serialize(Object obj) {
    String serialized = '';
    if (obj == null) {
      serialized = '';
    } else if (obj is String) {
      serialized = obj;
    } else {
      serialized = dson.encode(obj);
    }
    return serialized;
  }

  // We don't use a Map<String, String> for queryParams.
  // If collectionFormat is 'multi' a key might appear multiple times.
  Future<Response> invokeAPI(String path,
                             String method,
                             Iterable<QueryParam> queryParams,
                             Object body,
                             Map<String, String> headerParams,
                             Map<String, String> formParams,
                             String contentType,
                             List<String> authNames) async {

    _updateParamsForAuth(authNames, queryParams, headerParams);

    var ps = queryParams.where((p) => p.value != null).map((p) => '${p.name}=${p.value}');
    String queryString = ps.isNotEmpty ?
                         '?' + ps.join('&') :
                         '';

    String url = basePath + path + queryString;

    headerParams.addAll(_defaultHeaderMap);
    headerParams['Content-Type'] = contentType;

    if(body is MultipartRequest) {
      var request = new MultipartRequest(method, Uri.parse(url));
      request.fields.addAll(body.fields);
      request.files.addAll(body.files);
      request.headers.addAll(body.headers);
      request.headers.addAll(headerParams);
      var response = await client.send(request);
      return Response.fromStream(response);
    } else {
      var msgBody = contentType == "application/x-www-form-urlencoded" ? formParams : serialize(body);
      switch(method) {
        case "POST":
          return client.post(url, headers: headerParams, body: msgBody);
        case "PUT":
          return client.put(url, headers: headerParams, body: msgBody);
        case "DELETE":
          return client.delete(url, headers: headerParams);
        case "PATCH":
          return client.patch(url, headers: headerParams, body: msgBody);
        default:
          return client.get(url, headers: headerParams);
      }
    }
  }

  /// Update query and header parameters based on authentication settings.
  /// @param authNames The authentications to apply
  void _updateParamsForAuth(List<String> authNames, List<QueryParam> queryParams, Map<String, String> headerParams) {
    authNames.forEach((authName) {
      Authentication auth = _authentications[authName];
      if (auth == null) throw new ArgumentError("Authentication undefined: " + authName);
      auth.applyToParams(queryParams, headerParams);
    });
  }
}
